%global momorel 13

%define multilib_64_archs x86_64 s390x ppc64 sparc64
%define perl_archname %{_arch}-%{_os}-thread-multi
%define perlmodcompat 5.8.7 5.8.6 5.8.5
%define new_perl_lib  $RPM_BUILD_ROOT%{_libdir}/perl5/%{version}:$RPM_BUILD_ROOT/usr/lib/perl5/%{version}
%define comp_perl_lib $RPM_BUILD_ROOT/usr/lib/perl5/%{version}:$RPM_BUILD_ROOT/usr/lib/perl5/%{version}
%define new_arch_lib  $RPM_BUILD_ROOT%{_libdir}/perl5/%{version}/%{perl_archname}
%define comp_arch_lib $RPM_BUILD_ROOT/usr/lib/perl5/%{version}/%{perl_archname}
%define new_perl_flags LD_PRELOAD=/%{new_arch_lib}/CORE/libperl.so LD_LIBRARY_PATH=%{new_arch_lib}/CORE PERL5LIB=%{new_perl_lib}:%{comp_perl_lib}
%define new_perl %{new_perl_flags} $RPM_BUILD_ROOT/%{_bindir}/perl

%define perl_version 5.8.8
%define perl_epoch 4

# Use this for SUPER PERL DEBUGGING MODE.
%{?!perl_debugging:    %define perl_debugging 0}
%if %{perl_debugging}
%define debug_package %{nil}
# don't build debuginfo and disable stripping
%endif

Name:           perl
Version:        %{perl_version}
Release:        %{momorel}m%{?dist}
Epoch:          %{perl_epoch}
Summary:        The Perl programming language
Group:          Development/Languages
License:        Artistic or GPL
Url:            http://www.perl.org/
Source0:        http://www.cpan.org/authors/id/N/NW/NWCLARK/%{name}-%{perl_version}.tar.bz2
NoSource:       0
Source11:       filter-depends.sh
Source12:       perl-5.8.0-libnet.cfg
# Specific to Fedora/RHEL
Patch1:         perl-5.8.0-root.patch
# Upstream bug 41586
Patch2:         perl-5.8.8-incpush.patch
# Removes date check, Fedora/RHEL specific
Patch3:         perl-5.8.8-perlbug-tag.patch
# XXX: The next two patches appear to alter the order of @INC, but
# there isn't sufficient documentation as to why we do this.
Patch4:         perl-5.8.8-dashI.patch
Patch5:         perl-5.8.5-incorder.patch
# make sure we get the proper ldflags on libperl.so
# Upstream bug 41587
Patch6:         perl-5.8.0-sharedlinker.patch
# Fedora/RHEL use links instead of lynx
Patch7:         perl-5.8.8-links.patch
# work around annoying rpath issue
# This is only relevant for Fedora, as it is unlikely
# that upstream will assume the existence of a libperl.so
Patch8:         perl-5.8.8-rpath-make.patch
# Disable -DDEBUGGING and allow -g to do its job (#156113)
# Upstream bug 41588
Patch9:         perl-5.8.7-no-debugging.patch
# Upstream bug 41589
Patch10:        perl-5.8.1-fpic.patch
# Fedora/RHEL only (64bit only)
Patch11:        perl-5.8.0-libdir64.patch
# Upstream bug 41590
Patch12:        perl-5.8.0-nptlhint.patch
# Fedora/RHEL specific (use libresolv instead of libbind)
Patch13:        perl-5.8.6-libresolv.patch
# fix for bug 163958 / upstream bug 37056 :
# backport of perl-5.9's patch 25084 (bug still in 5.8.8!):
Patch14:        perl-5.8.7-25084.patch
# multi-threaded perl builds use localtime_r which does not call tzset
# bugzilla 172396
# Upstream bug 41591
Patch15:        perl-5.8.7-172396.patch
# Security fix
Patch16:        perl-5.8.8-CAN-2004-0976.patch
# XXX: Fixme
# Needs all the "Red Hat" references removed before upstreaming
Patch17:        perl-5.8.8-USE_MM_LD_RUN_PATH.patch
# Upstream bug 38385
Patch18:        perl-5.8.8-bz178343.patch
# Debian's fix for Net::NNTP:
# Upstream bug 41593
Patch19:        perl-5.8.8-debian_fix_net_nntp.patch
# Upstream patches 27133 and 27169 (27170):
Patch20:        perl-5.8.8-up27133_up27169.patch
# Upstream patch 27284:
Patch21:        perl-5.8.8-up27284.patch
# Fix for bug 183553 / upstream bug 38657:
Patch22:        perl-5.8.8-bz183553_ubz38657.patch
# http://rt.cpan.org/Ticket/Display.html?id=18692
Patch23:        perl-5.8.8-bz188441.patch
# Upstream bug 39130
Patch24:        perl-5.8.8-bz191416.patch
Patch25:        perl-5.8.8-U27116.patch
Patch26:        perl-5.8.8-U27391.patch
Patch27:        perl-5.8.8-U27426.patch
Patch28:        perl-5.8.8-U27509.patch
Patch29:        perl-5.8.8-U27512.patch
Patch30:        perl-5.8.8-U27604.patch
Patch31:        perl-5.8.8-U27605.patch
Patch32:        perl-5.8.8-U27914.patch
Patch33:        perl-5.8.8-U27329.patch
# XXX: Fixme
# Needs to be un-RedHatized before upstreaming
Patch34:        perl-5.8.8-R-switch.patch
# stop IPC/SysV.c including <asm/page.h> for getpagesize(), which
# is now declared by including <unistd.h> .
# Upstream bug 41594
Patch35:        perl-5.8.8-no_asm_page_h.patch
Patch36:        perl-5.8.8-U34297_C28006.patch
# Bugzilla 199372
# Upstream bug 41595
Patch37:        perl-5.8.8-useCFLAGSwithCC.patch
# Upstream bug 39903
Patch38:        perl-5.8.8-bz199736.patch
# XXX: Fixme - Finish patch.
Patch39:        perl-5.8.8-bz204679.patch
BuildRoot:      %{_tmppath}/%{name}-%{perl_version}-root
BuildRequires:  tcsh, dos2unix, man, groff
BuildRequires:  gdbm-devel, db4-devel

# XXX - remove this once RH bug #231549 is fixed
Requires:	perl-devel

# The long line of Perl provides.

Provides: /usr/bin/perl

# These provides are needed by the perl pkg itself with auto-generated perl.req
Provides: perl(VMS::Filespec)
Provides: perl(VMS::Stdio)

# Compat provides
Provides: perl(:MODULE_COMPAT_5.8.5)
Provides: perl(:MODULE_COMPAT_5.8.6)
Provides: perl(:MODULE_COMPAT_5.8.7)
Provides: perl(:MODULE_COMPAT_5.8.8)
# Threading provides
Provides: perl(:WITH_ITHREADS)
Provides: perl(:WITH_THREADS)
# Largefile provides
Provides: perl(:WITH_LARGEFILES)
# PerlIO provides
Provides: perl(:WITH_PERLIO)
# File provides
Provides: perl(abbrev.pl)
Provides: perl(assert.pl)
Provides: perl(bigfloat.pl)
Provides: perl(bigint.pl)
Provides: perl(bigrat.pl)
Provides: perl(bytes_heavy.pl)
Provides: perl(cacheout.pl)
Provides: perl(complete.pl)
Provides: perl(ctime.pl)
Provides: perl(dotsh.pl)
Provides: perl(dumpvar.pl)
Provides: perl(exceptions.pl)
Provides: perl(fastcwd.pl)
Provides: perl(find.pl)
Provides: perl(finddepth.pl)
Provides: perl(flush.pl)
Provides: perl(ftp.pl)
Provides: perl(getcwd.pl)
Provides: perl(getopt.pl)
Provides: perl(getopts.pl)
Provides: perl(hostname.pl)
Provides: perl(importenv.pl)
Provides: perl(look.pl)
Provides: perl(newgetopt.pl)
Provides: perl(open2.pl)
Provides: perl(open3.pl)
Provides: perl(perl5db.pl)
Provides: perl(pwd.pl)
Provides: perl(shellwords.pl)
Provides: perl(stat.pl)
Provides: perl(syslog.pl)
Provides: perl(tainted.pl)
Provides: perl(termcap.pl)
Provides: perl(timelocal.pl)
Provides: perl(utf8_heavy.pl)
Provides: perl(validate.pl)
Provides: perl(Carp::Heavy)
# Versioned Provides for our Obsoletes
Provides: perl-Filter-Simple = 0.82
Provides: perl-Time-HiRes = 1.86

# Last seen in Fedora Core 4
Obsoletes: perl-Filter-Simple
Obsoletes: perl-Time-HiRes

%define __perl_requires %{SOURCE11}


%description
Perl is a high-level programming language with roots in C, sed, awk
and shell scripting.  Perl is good at handling processes and files,
and is especially good at handling text.  Perl's hallmarks are
practicality and efficiency.  While it is used to do a lot of
different things, Perl's most common applications are system
administration utilities and web programming.  A large proportion of
the CGI scripts on the web are written in Perl.  You need the perl
package installed on your system so that your system can handle Perl
scripts.

Install this package if you want to program in Perl or enable your
system to handle Perl scripts.

%package devel
Summary:        Header files for use in perl development
Group:          Development/Languages
Requires:       perl = %{perl_epoch}:%{perl_version}-%{release}

%description devel
This package contains header files and development modules.
Most perl packages will need to install perl-devel to build.


%package suidperl
Summary:        Suidperl, for use with setuid perl scripts
Group:          Development/Languages
Requires:       perl = %{perl_epoch}:%{perl_version}-%{release}

%description suidperl
Suidperl is a setuid binary copy of perl that allows for (hopefully)
more secure running of setuid perl scripts.

%package CPAN
Summary:        Query, download and build perl modules from CPAN sites
Group:          Development/Languages
Epoch:          0
Version:        1.76_02
Requires:       perl = %{perl_epoch}:%{perl_version}-%{release}
Provides:       cpan = %{version}

%description CPAN
Query, download and build perl modules from CPAN sites.

%package ExtUtils-Embed
Summary:        Utilities for embedding Perl in C/C++ applications
Group:          Development/Languages
Epoch:          0
Version:        1.26
Requires:       perl-devel
Requires:       perl = %{perl_epoch}:%{perl_version}-%{release}

%description ExtUtils-Embed
Utilities for embedding Perl in C/C++ applications.

%package ExtUtils-MakeMaker
Summary:        Create a module Makefile
Group:          Development/Languages
Epoch:          0
Version:        6.30
Requires:       perl-devel
Requires:       perl = %{perl_epoch}:%{perl_version}-%{release}
Requires:       perl(Test::Harness)

%description ExtUtils-MakeMaker
Create a module Makefile.

%package Test-Harness
Summary:        Run Perl standard test scripts with statistics
Group:          Development/Languages
Epoch:          0
Version:        2.56
Requires:       perl-devel
Requires:       perl = %{perl_epoch}:%{perl_version}-%{release}

%description Test-Harness
Run Perl standard test scripts with statistics.

%package Test-Simple
Summary:        Basic utilities for writing tests
Group:          Development/Languages
Epoch:          0
Version:        0.62
Requires:       perl-devel
Requires:       perl = %{perl_epoch}:%{perl_version}-%{release}

%description Test-Simple
Basic utilities for writing tests.


%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%if !%{perl_debugging}
%patch9 -p1
%endif
%patch10 -p1
%ifarch %{multilib_64_archs}
%patch11 -p1
%endif
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
#
# Candidates for doc recoding (need case by case review):
# find . -name "*.pod" -o -name "README*" -o -name "*.pm" | xargs file -i | grep charset= | grep -v '\(us-ascii\|utf-8\)'
recode()
{
        iconv -f "$2" -t utf-8 < "$1" > "${1}_"
        mv -f "${1}_" "$1"
}
recode README.cn euc-cn
recode README.jp euc-jp
recode README.ko euc-kr
recode README.tw big5
recode pod/perlebcdic.pod iso-8859-1
recode pod/perlhack.pod iso-8859-1
recode pod/perlhist.pod iso-8859-1
recode pod/perlothrtut.pod iso-8859-1
recode pod/perlthrtut.pod iso-8859-1
recode lib/Unicode/Collate.pm iso-8859-1

find . -name \*.orig -exec rm -fv {} \;

# Oh, the irony. Perl generates some non-versioned provides we don't need.
# Each of these has a versioned provide, which we keep.
cat << \EOF > %{name}-prov
#!/bin/sh
%{__perl_provides} $* |\
    sed -e '/^perl(Carp)$/d' |\
    sed -e '/^perl(DynaLoader)$/d' |\
    sed -e '/^perl(Locale::Maketext)$/d' |\
    sed -e '/^perl(Math::BigInt)$/d' |\
    sed -e '/^perl(Net::Config)$/d' |\
    sed -e '/^perl(Tie::Hash)$/d' |\
    sed -e '/^perl(bigint)$/d' |\
    sed -e '/^perl(bigrat)$/d' |\
    sed -e '/^perl(bytes)$/d' |\
    sed -e '/^perl(utf8)$/d'
EOF
%define __perl_provides %{_builddir}/%{name}-%{perl_version}/%{name}-prov
chmod +x %{__perl_provides}


%build
echo "RPM Build arch: %{_arch}"

# yes; don't use %_libdir so that noarch packages from other OSs
# arches work correctly :\ the Configure lines below hardcode lib for
# similar reasons.

sh Configure -des -Doptimize="$RPM_OPT_FLAGS" \
        -Dversion=%{perl_version} \
        -Dmyhostname=localhost \
        -Dperladmin=root@localhost \
        -Dcc='%{__cc}' \
        -Dcf_by='Red Hat, Inc.' \
        -Dinstallprefix=%{_prefix} \
        -Dprefix=%{_prefix} \
%ifarch %{multilib_64_archs}
        -Dlibpth="/usr/local/lib64 /lib64 /usr/lib64" \
        -Dprivlib="/usr/lib/perl5/%{perl_version}" \
        -Dsitelib="/usr/lib/perl5/site_perl/%{perl_version}" \
        -Dvendorlib="/usr/lib/perl5/vendor_perl/%{perl_version}" \
        -Darchlib="%{_libdir}/perl5/%{perl_version}/%{perl_archname}" \
        -Dsitearch="%{_libdir}/perl5/site_perl/%{perl_version}/%{perl_archname}" \
        -Dvendorarch="%{_libdir}/perl5/vendor_perl/%{perl_version}/%{perl_archname}" \
%endif
        -Darchname=%{_arch}-%{_os} \
%ifarch sparc
        -Ud_longdbl \
%endif
        -Dvendorprefix=%{_prefix} \
        -Dsiteprefix=%{_prefix} \
        -Duseshrplib \
        -Dusethreads \
        -Duseithreads \
        -Duselargefiles \
        -Dd_dosuid \
        -Dd_semctl_semun \
        -Di_db \
        -Ui_ndbm \
        -Di_gdbm \
        -Di_shadow \
        -Di_syslog \
        -Dman3ext=3pm \
        -Duseperlio \
        -Dinstallusrbinperl=n \
        -Ubincompat5005 \
        -Uversiononly \
        -Dpager='/usr/bin/less -isr' \
        -Dd_gethostent_r_proto -Ud_endhostent_r_proto -Ud_sethostent_r_proto \
        -Ud_endprotoent_r_proto -Ud_setprotoent_r_proto \
        -Ud_endservent_r_proto -Ud_setservent_r_proto \
        -Dinc_version_list='%{perlmodcompat}' \
        -Dscriptdir='%{_bindir}'

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

%ifarch %{multilib_64_archs}
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/lib/perl5/%{perl_version}
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/lib/perl5/site_perl/%{perl_version}
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/lib/perl5/vendor_perl/%{perl_version}
%endif

%ifarch %{multilib_64_archs}
mkdir -p -m 755 ${RPM_BUILD_ROOT}/usr/lib64/perl5/vendor_perl/%{perl_version}/%{_arch}-%{_os}
%endif

#
# Compatibility directories
#
pushd $RPM_BUILD_ROOT/%{_libdir}/perl5
for i in %{perlmodcompat}; do
    mkdir -pm 755 $i/%{perl_archname}/CORE
    mkdir -pm 755 $i/%{perl_archname}/auto
    pushd $i/%{perl_archname}/CORE
      ln -s ../../../%{perl_version}/%{perl_archname}/CORE/libperl.so libperl.so
    popd
  done
popd

install -p -m 755 utils/pl2pm ${RPM_BUILD_ROOT}%{_bindir}/pl2pm

for i in asm/termios.h syscall.h syslimits.h syslog.h sys/ioctl.h sys/socket.h sys/time.h wait.h
do
  %{new_perl} $RPM_BUILD_ROOT/%{_bindir}/h2ph -a \
              -d $RPM_BUILD_ROOT%{_libdir}/perl5/%{perl_version}/%{perl_archname} $i || /bin/true
done


for dir in $(%{new_perl} -le 'print join("\n", @INC)' | grep '^/usr/lib')
do
  mkdir -p $RPM_BUILD_ROOT/$dir
done

for dir in $(%{new_perl} -le 'print join("\n", @INC)' | grep '^%{_libdir}')
do
  mkdir -p $RPM_BUILD_ROOT/$dir
done

for i in %{perl_version} %{perlmodcompat} ; do
  mkdir -pm 755 $RPM_BUILD_ROOT%{_libdir}/perl5/site_perl/$i/%{perl_archname}/auto
  mkdir -pm 755 $RPM_BUILD_ROOT%{_libdir}/perl5/vendor_perl/$i/%{perl_archname}/auto
done


#
# libnet configuration file
#
mkdir -p -m 755 $RPM_BUILD_ROOT/%{_libdir}/perl5/%{perl_version}/Net
install -p -m 644 %{SOURCE12} $RPM_BUILD_ROOT/%{_libdir}/perl5/%{perl_version}/Net/libnet.cfg

#
# Core modules removal
#
find $RPM_BUILD_ROOT -name '*NDBM*' | xargs rm -rfv
find $RPM_BUILD_ROOT -name '*Math*' | xargs rm -rfv

find $RPM_BUILD_ROOT -type f -name '*.bs' -a -empty -exec rm -f {} ';'

# Cleanup binary paths and make cgi files executable
pushd $RPM_BUILD_ROOT/usr/lib/perl5/%{perl_version}/CGI/eg/
  for i in *.cgi make_links.pl RunMeFirst ; do
    sed -i 's|/usr/local/bin/perl|/usr/bin/perl|g' $i
    chmod +x $i
  done
popd

# miniperl? As an interpreter? How odd.
sed -i 's|./miniperl|/usr/bin/perl|' $RPM_BUILD_ROOT/usr/lib/perl5/%{perl_version}/ExtUtils/xsubpp
chmod +x $RPM_BUILD_ROOT/usr/lib/perl5/%{perl_version}/ExtUtils/xsubpp

# Don't need the .packlist
rm -f $RPM_BUILD_ROOT%{_libdir}/perl5/%{perl_version}/%{perl_archname}/.packlist

# Fix some manpages to be UTF-8
pushd $RPM_BUILD_ROOT%{_mandir}/man1/
  for i in perl588delta.1 perldelta.1 ; do
    iconv -f MS-ANSI -t UTF-8 $i --output new-$i
    rm -rf $i
    mv new-$i $i
  done
popd

# Mo files fix
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/lib/perl5/vendor_perl/%{perl_version}/ExtUtils
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/lib/perl5/vendor_perl/%{perl_version}/Locale
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/lib/perl5/vendor_perl/%{perl_version}/Net
#

chmod -R u+w $RPM_BUILD_ROOT/*
%if %{perl_debugging}
exit 0
# disable brp-strip
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%check
make test

%files
%defattr(-,root,root,-)
%doc Copying README
%{_mandir}/man1/*.1*
%{_mandir}/man3/*.3*
%{_bindir}/*
%{_libdir}/perl5/
%ifarch %{multilib_64_archs}
/usr/lib/perl5/
%endif
%exclude %{_bindir}/enc2xs
%exclude %{_mandir}/man1/enc2xs*
%exclude %{_bindir}/h2xs
%exclude %{_mandir}/man1/h2xs*
%exclude %{_bindir}/libnetcfg
%exclude %{_mandir}/man1/libnetcfg*
%exclude %{_bindir}/perlcc
%exclude %{_mandir}/man1/perlcc*
%exclude %{_bindir}/perlivp
%exclude %{_mandir}/man1/perlivp*
%exclude %{_bindir}/suidperl
%exclude %{_bindir}/sperl%{perl_version}
%exclude %{_libdir}/perl5/%{perl_version}/%{perl_archname}/CORE/*.h
# CPAN
%exclude %{_bindir}/cpan
%exclude /usr/lib/perl5/%{perl_version}/CPAN/
%exclude /usr/lib/perl5/%{perl_version}/CPAN.pm
%exclude %{_mandir}/man1/cpan.1*
%exclude %{_mandir}/man3/CPAN*
# ExtUtils-Embed
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/Embed.pm
%exclude %{_mandir}/man3/ExtUtils::Embed*
# ExtUtils-MakeMaker
%exclude %{_bindir}/instmodsh
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/Command/
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/Install.pm
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/Installed.pm
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/Liblist/
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/Liblist.pm
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/MakeMaker/
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/MakeMaker.pm
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/MANIFEST.SKIP
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/MM*.pm
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/MY.pm
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/Manifest.pm
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/Mkbootstrap.pm
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/Mksymlists.pm
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/NOTES
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/Packlist.pm
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/PATCHING
%exclude /usr/lib/perl5/%{perl_version}/ExtUtils/testlib.pm
%exclude %{_mandir}/man1/instmodsh.1*
%exclude %{_mandir}/man3/ExtUtils::Command::MM*
%exclude %{_mandir}/man3/ExtUtils::Install.3*
%exclude %{_mandir}/man3/ExtUtils::Installed.3*
%exclude %{_mandir}/man3/ExtUtils::Liblist.3*
%exclude %{_mandir}/man3/ExtUtils::MM*
%exclude %{_mandir}/man3/ExtUtils::MY.3*
%exclude %{_mandir}/man3/ExtUtils::MakeMaker*
%exclude %{_mandir}/man3/ExtUtils::Manifest.3*
%exclude %{_mandir}/man3/ExtUtils::Mkbootstrap.3*
%exclude %{_mandir}/man3/ExtUtils::Mksymlists.3*
%exclude %{_mandir}/man3/ExtUtils::Packlist.3*
%exclude %{_mandir}/man3/ExtUtils::testlib.3*
# Test::Harness
%exclude %{_bindir}/prove
%exclude /usr/lib/perl5/%{perl_version}/Test/Harness*
%exclude %{_mandir}/man1/prove.1*
%exclude %{_mandir}/man3/Test::Harness*
# Test::Simple
%exclude %{_prefix}/lib/perl5/%{perl_version}/Test/More*
%exclude %{_prefix}/lib/perl5/%{perl_version}/Test/Builder*
%exclude %{_prefix}/lib/perl5/%{perl_version}/Test/Simple*
%exclude %{_prefix}/lib/perl5/%{perl_version}/Test/Tutorial*
%exclude %{_mandir}/man3/Test::More*
%exclude %{_mandir}/man3/Test::Builder*
%exclude %{_mandir}/man3/Test::Simple*
%exclude %{_mandir}/man3/Test::Tutorial*
# Mo files fix
#/usr/lib/perl5/vendor_perl/%%{perl_version}/ExtUtils
#/usr/lib/perl5/vendor_perl/%%{perl_version}/Locale
#/usr/lib/perl5/vendor_perl%/%{perl_version}/Net

%files devel
%defattr(-,root,root,-)
%{_bindir}/enc2xs
%{_mandir}/man1/enc2xs*
%{_bindir}/h2xs
%{_mandir}/man1/h2xs*
%{_bindir}/libnetcfg
%{_mandir}/man1/libnetcfg*
%{_bindir}/perlcc
%{_mandir}/man1/perlcc*
%{_bindir}/perlivp
%{_mandir}/man1/perlivp*
%{_libdir}/perl5/%{perl_version}/%{perl_archname}/CORE/*.h

%files CPAN
%{_bindir}/cpan
/usr/lib/perl5/%{perl_version}/CPAN/
/usr/lib/perl5/%{perl_version}/CPAN.pm
%{_mandir}/man1/cpan.1*
%{_mandir}/man3/CPAN*

%files ExtUtils-Embed
/usr/lib/perl5/%{perl_version}/ExtUtils/Embed.pm
%{_mandir}/man3/ExtUtils::Embed*

%files ExtUtils-MakeMaker
%{_bindir}/instmodsh
/usr/lib/perl5/%{perl_version}/ExtUtils/Command/
/usr/lib/perl5/%{perl_version}/ExtUtils/Install.pm
/usr/lib/perl5/%{perl_version}/ExtUtils/Installed.pm
/usr/lib/perl5/%{perl_version}/ExtUtils/Liblist/
/usr/lib/perl5/%{perl_version}/ExtUtils/Liblist.pm
/usr/lib/perl5/%{perl_version}/ExtUtils/MakeMaker/
/usr/lib/perl5/%{perl_version}/ExtUtils/MakeMaker.pm
/usr/lib/perl5/%{perl_version}/ExtUtils/MANIFEST.SKIP
/usr/lib/perl5/%{perl_version}/ExtUtils/MM*.pm
/usr/lib/perl5/%{perl_version}/ExtUtils/MY.pm
/usr/lib/perl5/%{perl_version}/ExtUtils/Manifest.pm
/usr/lib/perl5/%{perl_version}/ExtUtils/Mkbootstrap.pm
/usr/lib/perl5/%{perl_version}/ExtUtils/Mksymlists.pm
/usr/lib/perl5/%{perl_version}/ExtUtils/NOTES
/usr/lib/perl5/%{perl_version}/ExtUtils/Packlist.pm
/usr/lib/perl5/%{perl_version}/ExtUtils/PATCHING
/usr/lib/perl5/%{perl_version}/ExtUtils/testlib.pm
%{_mandir}/man1/instmodsh.1*
%{_mandir}/man3/ExtUtils::Command::MM*
%{_mandir}/man3/ExtUtils::Install.3*
%{_mandir}/man3/ExtUtils::Installed.3*
%{_mandir}/man3/ExtUtils::Liblist.3*
%{_mandir}/man3/ExtUtils::MM*
%{_mandir}/man3/ExtUtils::MY.3*
%{_mandir}/man3/ExtUtils::MakeMaker*
%{_mandir}/man3/ExtUtils::Manifest.3*
%{_mandir}/man3/ExtUtils::Mkbootstrap.3*
%{_mandir}/man3/ExtUtils::Mksymlists.3*
%{_mandir}/man3/ExtUtils::Packlist.3*
%{_mandir}/man3/ExtUtils::testlib.3*

%files Test-Harness
%{_bindir}/prove
/usr/lib/perl5/%{perl_version}/Test/Harness*
%{_mandir}/man1/prove.1*
%{_mandir}/man3/Test::Harness*

%files Test-Simple
%defattr(-,root,root,-)
%{_prefix}/lib/perl5/%{perl_version}/Test/More*
%{_prefix}/lib/perl5/%{perl_version}/Test/Builder*
%{_prefix}/lib/perl5/%{perl_version}/Test/Simple*
%{_prefix}/lib/perl5/%{perl_version}/Test/Tutorial*
%{_mandir}/man3/Test::More*
%{_mandir}/man3/Test::Builder*
%{_mandir}/man3/Test::Simple*
%{_mandir}/man3/Test::Tutorial*

%files suidperl
%defattr(-,root,root,-)
%{_bindir}/suidperl
%{_bindir}/sperl%{perl_version}

%changelog
* Sun Jul  8 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (5.8.8-13m)
- roll back to 11m (sorry...)

* Sun Jul  8 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (5.8.8-12m)
- fix conflicting man

* Sat Jul  7 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (5.8.8-11m)
- sync with FC-devel
- following sub-packages are generated from perl.spec
- ExtUtils-MakeMaker, ExtUtils-Embed, CPAN, Test-Harness, Test-Simple

* Tue Apr 24 2007 TABUCHI Takaaki <tab@momonga-linux.org>
- (5.8.8-10m)
- fix files dup

* Tue Apr 24 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (5.8.8-9m)
- delete Math modules again

* Sun Apr 22 2007 Masahiro Takahata <takahata@momonga-linux>
- (5.8.8-8m)
- sync with fedora

* Thu Mar 15 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (5.8.8-7m)
- add gcc-4.2 patch
-- perl-5.8.8-gcc42.patch

* Wed Jan 31 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (5.8.8-6m)
- delete Math modules

* Fri Nov 17 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (5.8.8-5m)
- rebuild against db-4.5

* Sun May 28 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (5.8.8-4m)
- add Provides: perl(Mac::InternetConfig)

* Tue Feb 21 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (5.8.8-3m)
- change URL for Source0 
- use Patch19:     perl-5.8.8-links.patch     
- add Patch32:     perl-5.8.8-debian_fix_net_nntp.patch
      Patch33:     perl-5.8.8-up27133_up27169.patch
      Patch25084:  perl-5.8.7-25084.patch
- add BuildRequires: man, groff

* Sat Feb 11 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (5.8.8-2m)
- edit spec to include DB_File and fix typos (sumaaan m<..>m 

* Tue Feb 7 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (5.8.8-1m)
- version up to 5.8.8
- import patch from fedora

* Sun Oct 16 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (5.8.7-2m)
- enable ia64.

* Wed Jun  8 2005 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (5.8.7-1m)
- version up to 5.8.7

* Fri Jan 14 2005 Toru Hoshina <t@momonga-linux.org>
- (5.8.5-2m)
- enable x86_64.

* Wed Aug 11 2004 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (5.8.5-1m)
- version update to 5.8.5
- remove Patch8: perl-5.8.0-errno.patch 

* Mon Jul 12 2004 Kazuhiko <kazuhiko@fdiary.net>
- (5.8.2-9m)
- add Epoch to Requires: of perl-suidperl

* Mon Jul 12 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (5.8.2-8m)
- add Epoch

* Sun Jul 11 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (5.8.2-7m)
- remove Epoch

* Sat Apr  4 2004 Toru Hoshina <t@momonga-linux.org>
- (5.8.2-6m)
- revised spec for rpm 4.2.1.

* Mon Dec 15 2003 TAKAHASHI Tamotsu <tamo>
- (5.8.2-5m)
- add 'Provides: /usr/bin/suidperl'

* Mon Dec  1 2003 Kazuhiko <kazuhiko@fdiary.net>
- (5.8.2-3m)
- remove 'Provides: /usr/bin/perl5'

* Sun Nov 30 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (5.8.2-3m)
- remove Obsoletes: perl-Time-HiRes
- remove Provides: perl-Time-HiRes
- delete DB_File

* Sat Nov 29 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (5.8.2-2m)
- import patch from fedora

* Sun Nov 10 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (5.8.2-1m)
- update to 5.8.2
- comment out %%patch21397 -p1 -b .21397 since included tarball
- comment out %%patch21401 -p1 -b .21401 since included tarball

* Mon Nov 10 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (5.8.1-2m)
- rebuild against gdbm-1.8.0

* Sat Nov 01 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (5.8.1-1m)
- update to 5.8.1
- s/%%define/%%global/g
- comment out unused %%define cpanver, dbfilever and cgiver
- add Patch19: perl-5.8.0-links.patch
- add Patch21: perl-5.8.0-rpath-make.patch
- add Patch21397: perl-5.8.1-upstream-21397.patch from rawhide
- add Patch21401: perl-5.8.1-upstream-21401.patch from rawhide
- add gdbm-devel, db4-devel at BuildRequires:
- add URL: http://www.perl.com/
- use %%{perlver} instead of perl version hard coding '5.8.0'!!
- update Patch5: to perl-5.8.0-root.patch
- comment out Patch6: perl-5.8.0-fhs.patch
- comment out Patch9: perl-5.7.3-syslog.patch
- comment out Patch20: perl-5.8.0-pager.patch
- comment out Patch200: perl-5.8.0-local-utf8.patch
- comment out Patch201: perl-5.8.0-upstream-17781.patch
- comment out Patch202: perl-5.8.0-upstream-17927.patch
- comment out Patch206: perl-5.8.0-upstream-18061.patch
- comment out Patch207: perl-5.8.0-upstream-18086.patch
- add many Provides:, is this correct?
- update source11 filter-depends.sh for 'grep -v perl(Tk'

* Wed Oct 29 2003 Masaru SANUKI <sanuki@hh.iij4u.or.jp>
- (5.8.0-9m)
- adapt the License: preamble for the Momonga Linux license
  expression unification policy (draft)
- add %%{momorel}

* Tue Aug 26 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (5.8.0-8m)
- remove perl-5.8.0-db.patch

* Sat Jul 26 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (5.8.0-7m)
- update CGI.pm to fix vulnerability of Cross-site Scripting 
   See:
      http://www.st.ryukoku.ac.jp/%7Ekjm/security/memo/2003/07.html#20030723_cgi.pm
      http://archives.neohapsis.com/archives/bugtraq/2003-07/0267.html
      http://archives.neohapsis.com/archives/bugtraq/2003-07/0287.html

* Mon Feb 10 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (5.8.0-6m)
- rebuild against for gdbm

* Sat Feb  8 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (5.8.0-5m)
- rebuild against gdbm-1.8.3-1m

* Sun Feb  2 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (5.8.0-4m)
- add following Provides
  - Provides: perl-Digest-MD5
  - Provides: perl-MIME-Base64
  - Provides: perl-libnet
  - Provides: perl-Storable
  - Provides: perl-Test-Harness
  - Provides: perl-Test-Simple
  - Provides: perl-Time-HiRes

* Mon Nov 25 2002 Shingo Akagaki <dora@kitty.dnsalias.org>
- (5.8.0-3m)
- provides /usr/bin/perl, /usr/bin/perl5

* Mon Nov 25 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (5.8.0-2m)
- fix thread support

* Thu Nov 21 2002 Kazuhiko <kazuhiko@fdiary.net>
- (5.8.0-1m)
- merged from rawhide

* Thu Nov  7 2002 Chip Turner <cturner@redhat.com>
- multilib support when building noarch perl modules
- integrate upstream bugfix patches

* Tue Sep 10 2002 Chip Turner <cturner@redhat.com>
- integrate patch for /usr/lib64 instead of /usr/lib from Than Ngo

* Mon Sep  9 2002 Chip Turner <cturner@redhat.com>
- integrate s390/s390x patch from Florian La Roche

* Sun Sep  1 2002 Chip Turner <cturner@redhat.com>
- fix pager issues; default to /usr/bin/less -isr
- more work on pager bug (72125)

* Thu Aug 29 2002 Chip Turner <cturner@redhat.com>
- add a few new directories to h2ph to produce better .ph files

* Thu Aug 15 2002 Chip Turner <cturner@redhat.com>
- change from lynx to links in CPAN.pm

* Tue Aug  6 2002 Chip Turner <cturner@redhat.com>
- automated release bump and build
- remove Filter packages and use CPAN ones

* Fri Jul 19 2002 Chip Turner <cturner@redhat.com>
- move to final perl 5.8.0, huzzah!

* Tue Jul 16 2002 Chip Turner <cturner@redhat.com>
- update CPAN, CGI, and DB_File versions; obsolete perl-libnet
- libnet.cfg supplied, default to passive ftp in all cases

* Tue Jun 18 2002 Chip Turner <cturner@redhat.com>
- add patch to ensire libperl.so is linked properly

* Mon May 20 2002 Nalin Dahyabhai <nalin@redhat.com>
- always build with -fPIC

* Thu May  9 2002 Jeff Johnson <jbj@redhat.com>
- rebuild in rawhide

* Sun Mar 31 2002 Chip Turner <cturner@redhat.com>
- split suidperl back out (bug #62215)

* Tue Mar 26 2002 Chip Turner <cturner@redhat.com>
- restructuring of some directories, alteration of @INC

* Thu Dec 20 2001 Chip Turner <cturner@redhat.com>
- remove ndbm completely

* Sun Dec 16 2001 Chip Turner <cturner@redhat.com>
- make rpmlint happy, split out NDBM_File, clean up other spots
- stopped doing grep -v etc in favor of custom script

* Wed Dec 12 2001 Chip Turner <cturner@redhat.com>
- cleaning up of ia64 issues, as well as compatibility with gcc 3.1
  and glibc 2.2.4

* Mon Sep 24 2001 Chip Turner <cturner@redhat.com>
- changing building of extra modules out of the core perl rpm

* Mon Sep 17 2001 Chip Turner <cturner@redhat.com>
- upgrade to 5.6.1, added old INC dirs to maintain compat

* Fri Mar 23 2001 Preston Brown <pbrown@redhat.com>
- bzip2 source, save some space.

* Thu Dec  7 2000 Crutcher Dunnavant <crutcher@redhat.com>
- initial rebuild for 7.1

* Tue Sep 12 2000 Bill Nottingham <notting@redhat.com>
- fix dependencies on ia64/sparc64

* Mon Aug  7 2000 Nalin Dahyabhai <nalin@redhat.com>
- replace the deprecated MD5 with Digest::MD5 (has to be here for cleanfeed)
- obsolete: perl-Digest-MD5
- use syslog instead of mail to report possible attempts to break into suidperl
- force syslog on at build-time

* Mon Jul 31 2000 Nalin Dahyabhai <nalin@redhat.com>
- add Owen's fix for #14779/#14863
- specify cc=%{__cc}; continue to let cpp sort itself out
- switch shadow support on (#8646)
- release 7

* Tue Jul 18 2000 Nalin Dahyabhai <nalin@redhat.com>
- strip buildroot from perl pods (#14040)
- release 6

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild (release 5)

* Wed Jun 21 2000 Preston Brown <pbrown@redhat.com>
- don't require tcsh to install, only to build
- release 4

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild against new db3 package
- release 3

* Sat Jun 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- disable 64-bit file support
- change name of package that Perl expects gcc to be in from "egcs" to "gcc"
- move man pages to /usr/share via hints/linux.sh and MM_Unix.pm
- fix problems prefixifying with empty prefixes
- disable long doubles on sparc (they're the same as doubles anyway)
- add an Epoch to make sure we can upgrade from perl-5.00503
- release 2

* Thu Mar 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.6.0

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- fix description

* Fri Jan 14 2000 Jeff Johnson <jbj@redhat.com>
- add provides for perl modules (from kestes@staff.mail.com).

* Mon Oct 04 1999 Cristian Gafton <gafton@redhat.com>
- fix the %install so that the MD5 module gets actually installed correctly

* Mon Aug 30 1999 Cristian Gafton <gafton@redhat.com>
- make sure the package builds even when we don't have perl installed on the
  system

* Fri Aug 06 1999 Cristian Gafton <gafton@redhat.com>
- merged with perl-MD5
- get rid of the annoying $RPM_BUILD_ROOT paths in the installed tree

* Mon Jul 26 1999 Cristian Gafton <gafton@redhat.com>
- do not link anymore against the system db library (and make each module
  link against it separately, so that we can have Berkeley db1 and db2 mixed
  up)

* Wed Jun 16 1999 Cristian Gafton <gafton@redhat.com>
- use wildcards for files in /usr/bin and /usr/man

* Tue Apr 06 1999 Cristian Gafton <gafton@redhat.com>
- version 5.00503
- make the default man3 install dir be release independent
- try to link against db1 to preserve compatibility with older databases;
  abandoned idea because perl is too broken to allow such an easy change
  (hardcoded names *everywhere* !!!)

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Thu Jan 07 1999 Cristian Gafton <gafton@redhat.com>
- guilty of the inlined Makefile in the spec file
- adapted for the arm build

* Wed Sep 09 1998 Preston Brown <pbrown@redhat.com>
- added newer CGI.pm to the build
- changed the version naming scheme around to work with RPM

* Sun Jul 19 1998 Jeff Johnson <jbj@redhat.com>
- attempt to generate *.ph files reproducibly

* Mon Jun 15 1998 Jeff Johnson <jbj@redhat.com>
- update to 5.004_04-m4 (pre-5.005 maintenance release)

* Tue Jun 12 1998 Christopher McCrory <chrismcc@netus.com
- need stdarg.h from gcc shadow to fix "use Sys::Syslog" (problem #635)

* Fri May 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to correct the .ph constructs unless defined (foo) to read
  unless(defined(foo))

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Mar 10 1998 Cristian Gafton <gafton@redhat.com>
- fixed strftime problem

* Sun Mar 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to fix a security race
- do not use setres[ug]id - those are not implemented on 2.0.3x kernels

* Mon Mar 02 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 5.004_04 - 5.004_01 had some nasty memory leaks.
- fixed the spec file to be version-independent

* Fri Dec 05 1997 Erik Troan <ewt@redhat.com>
- Config.pm wasn't right do to the builtrooting

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- fixed arch-specfic part of spec file

* Sun Oct 19 1997 Erik Troan <ewt@redhat.com>
- updated to perl 5.004_01
- users a build root

* Thu Jun 12 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Apr 22 1997 Erik Troan <ewt@redhat.com>
- Incorporated security patch from Chip Salzenberg <salzench@nielsenmedia.com>

* Fri Feb 07 1997 Erik Troan <ewt@redhat.com>
- Use -Darchname=i386-linux 
- Require csh (for glob)
- Use RPM_ARCH during configuration and installation for arch independence
